* handler.s  for trace.x
*
*	F line trap handler ( most of code is from human.sys )
*
*	K.Abe
*
*	some subroutines
*
*	Patch for Human3.02 by Tachibana Eriko


			.ifndef	HUMAN_VERSION
HUMAN_VERSION:		.equ	0x302
			.endif
; Human68k ver 3.02 ȊOŎgpꍇ͂ύX邱.
; 2.02,2.03(̈),3.01,3.02 ȊO͑ΉĂȂ.

STACK_SIZE:		.equ	8192
			.fail	(STACK_SIZE.lt.4096).or.(STACK_SIZE.and.%11)


* Include File -------------------------------- *

		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xdef	_usage
		.xdef	_check_human_version
		.xdef	_error_exit
		.xdef	_setup_doscall_handler
		.xdef	_restore_doscall_handler

		.xref	_Stream			* trace.c

		.xref	_display1		* display.c
		.xref	_display2		*

		.xref	__iob			* LIBC
		.xref	_exit			*
		.xref	_fputs			*


* Fixed Number -------------------------------- *

stderr:			.reg	__iob+36*2

FLINE_TRAP_VEC:		.equ	11
FLINE_TRAP_VECADR:	.equ	4*FLINE_TRAP_VEC

LF:			.equ	$0a
EXIT_FAILURE:		.equ	1

* IOCS [N
CSRX:			.equ	$974

* o[Wˑ
		.if	HUMAN_VERSION.eq.0x202
OScode_abort_check:	.equ	$8176	* A{[g?(trap #10/11)
OScode_change_process:	.equ	$e168	* vZX؂芷
		.elseif	HUMAN_VERSION.eq.0x203
OScode_abort_check:	.equ	$80b8
OScode_change_process:	.equ	$df88
		.elseif	HUMAN_VERSION.eq.0x301
OScode_abort_check:	.equ	$869e
OScode_change_process:	.equ	$df3a
		.else	HUMAN_VERSION.eq.0x302
OScode_abort_check:	.equ	$8740
OScode_change_process:	.equ	$e050
		.endif

* OS [N
DOS_callVectorTable_1800:	.equ	$1800
WK_DOS_call_counter_1C08:	.equ	$1c08
WK_DOS_function_No_1C0A:	.equ	$1c0a
WK_DOS_want_call_prcs_switcher_1C14:	.equ	$1c14
DOS_call_stack_save_1C5C:	.equ	$1c5c
WK_cur_FCB_adrs_1C98:		.equ	$1c98


* Macro --------------------------------------- *

PUSH:		.macro	regs
		movem.l	regs,-(sp)
		.endm

POP:		.macro	regs
		movem.l	(sp)+,regs
		.endm


* Text Section -------------------------------- *

		.text

		.quad
_Old_handler:	.dc.l	0


_New_handler:
		PUSH	d0/a5-a6		* L008598@human3.02
		lea	(4*3+2,sp),a6
		movea.l	(a6),a5			* a5 = (pc)
		move	(a5)+,d0		* get traped instruction

		cmpi	#$fff5,d0
		bcc	not_doscall
		cmpi	#$ff00,d0
		bcs	not_doscall

		move.l	a5,(a6)+		* next pc is 2byte after
		tst.b	($cbc)
		beq	@f
		addq.l	#2,a6			* 68010-
@@:
		addq.l	#4,sp			* j󂪊m肵d0.l̕
		PUSH	d1-d7/a0-a4

		btst	#5,(4*(7+5+2),sp)	* super?
		bne	@f
		move.l	usp,a6
@@:
* 
		move.l	sp,(stack_buffer)
		lea	(mystack),sp
		move.l	(_Old_handler,pc),(FLINE_TRAP_VECADR)
		move.l	a6,-(sp)
		move.l	d0,-(sp)
		bsr	_display1		* send DOS CALL NUMBER and ARGUMENT
		move.l	(sp)+,d0
		addq.l	#4,sp
		move.l	#_New_handler,(FLINE_TRAP_VECADR)
		movea.l	(sp),sp
* ܂
		moveq	#0,d1
		move.b	d0,d1
		move.l	d1,d0
		lea	(DOS_callVectorTable_1800),a0
		add	d1,d1
		add	d1,d1
		movea.l	(a0,d1.w),a0

		tst	(WK_DOS_call_counter_1C08)
		bne	@f

		move.l	sp,(DOS_call_stack_save_1C5C)	* 򒼑Ossp
		move.b	d0,(WK_DOS_function_No_1C0A)	* sDOSR[ԍ
@@:
		addq	#1,(WK_DOS_call_counter_1C08)	* inDOStO
		clr.l	(WK_cur_FCB_adrs_1C98)		* ???
		jsr	(a0)
		clr.l	(WK_cur_FCB_adrs_1C98)
		subq	#1,(WK_DOS_call_counter_1C08)
		bne	@f

		clr.b	(WK_DOS_function_No_1C0A)	* DOSR[̎sI
@@:
		move.l	d0,-(sp)
		jsr	(OScode_abort_check)
* 
		move.l	sp,(stack_buffer)
		lea	(mystack),sp
		move.l	(_Old_handler,pc),(FLINE_TRAP_VECADR)
		move.l	d0,-(sp)
		bsr	_display2		* send RESULT CODE
		addq.l	#4,sp
		move.l	#_New_handler,(FLINE_TRAP_VECADR)
		movea.l	(sp),sp
* ܂
		POP	d0-d7/a0-a6

		tst.b	(WK_DOS_want_call_prcs_switcher_1C14)
		beq	@f			* vZX؂芷XCb`
		jmp	(OScode_change_process)
@@:
*		btst	#SR_T_bit,(sp)
		tst	(sp)
		bpl	@f
		ori	#$8000,sr
@@:
		rte

not_doscall:
		POP	d0/a5-a6
		move.l	(_Old_handler,pc),-(sp)
		rts


* Sub Routines -------------------------------- *

* extern void usage( void );

_usage:
		pea	(usage_message,pc)
		bra	_error_exit

* extern void check_human_version( void );

_check_human_version:
		DOS	_VERNUM
		cmpi	#HUMAN_VERSION,d0
		beq	human_version_ok

		pea	(version_error_message,pc)
		bra	_error_exit

* extern void error_exit( const char *format );

_error_exit:
		move.l	#stderr,(4,sp)
		bsr	_fputs
		pea	(EXIT_FAILURE)
		bsr	_exit

* extern void setup_doscall_handler( void );

_setup_doscall_handler:
		lea	(_New_handler,pc),a1
		bsr	intvcs_fline
		move.l	d0,(_Old_handler)
human_version_ok:
		rts

* extern void restore_doscall_handler( void );

_restore_doscall_handler:
		movea.l	(_Old_handler,pc),a1
intvcs_fline:
		move	#FLINE_TRAP_VEC,d1
		IOCS	_B_INTVCS
		rts

*		.data

usage_message:
		.dc.b	'DOS call tracer version 0.20 Copyright (C)1991,1995 K.Abe,Eriko',LF
		.dc.b	'usage: trace [-a] [-o file] command arg ...',LF,0
version_error_message:
		.dc.b	'trace: this version of human68k is not supported.',LF,0

*		.text
		.even


* Stack Section ------------------------------- *

		.bss
		.quad

		.ds.b	STACK_SIZE
mystack:
stack_buffer:	.ds.l	1			* mystack == stack_buffer ł邱


* End of Source ------------------------------- *

		.end
